package de.beyondjava.simpleClassParser;

import static de.beyondjava.simpleClassParser.RegularExpressions.*

import java.util.regex.Matcher

import com.google.gson.Gson

/**
 * This is the definition of a method (without the implementation details and without the parameter list).
 */
public class MethodDefinition {
	List<String> visibility = []
	String name
	String type
	List<String> annotations=[]
	String parameters
	boolean isConstructor


	MethodDefinition(String p_method, String p_classNameForDebugging) {
		try
		{
			Matcher m = p_method =~ ANNOTATION
			m.each({annotations = annotations + it[0].trim()})
			// simplify expression by removing annotations
			String method = p_method.replaceAll(ANNOTATION, "")
			// extract parameter list
			m = method =~ PARAMETERS
			m.each({parameters = it[0].trim()})
			// simplify expression by removing parameters
			method = method.replaceAll(PARAMETERS, "")

			String[] words = method.split(NON_EMPTY_SPACE.toString())
			name=words[-1]
			if (words.size()==1 || words[-2] == "public" || words[-2] == "private" || words[-2] == "protected")
			{
				isConstructor = true
				if (words.length > 1) {
					visibility=words[0..-2]
				}
			}
			else
			{
				type=words[-2]
				if (words.length > 2) {
					visibility=words[0..-3]
				}
			}
		}
		catch (Exception p_error)
		{
			println "An error occured while parsing $p_classNameForDebugging: $p_error"
			println "while trying to evaluate the variable: '$p_method'"
		}
	}

	public String toString()
	{
		Gson g = new Gson();
		g.toJson(this)
	}

	public MethodDefinition clone()
	{
		Gson g = new Gson();
		g.fromJson(g.toJson(this), MethodDefinition.class)
	}

}
