package de.beyondjava.simpleClassParser

import java.util.regex.Pattern;

class RegularExpressions {
	final static Pattern STRING_REGEXP = ~ /('(.)*?')/
	final static Pattern STRING2_REGEXP = ~ /("""(.)*?""")/
	final static Pattern STRING3_REGEXP = ~ /("(.)*?")/
	final static String STRING4_REGEXP = "(~\\s)(\\/(.)+?\\/)"
	final static Pattern SPACE = ~ /(\s)*/
	final static Pattern IDENTIFIER = ~ /(\w|_|\$)+/
	final static Pattern TYPEIDENTIFIER = ~ /(\w|_|\$|<|>|\[|\])+/
	final static Pattern MODIFIERS = ~ /((\s)*(final|volatile|transient|static|public|private|protected)(\s)+)*/
	final static Pattern PARAMETERS = ~ /\((\w|_|,|\$|\s|=|<|>|\[|\]|($STRING2_REGEXP)|($STRING3_REGEXP))*\)/
	final static Pattern ANNOTATION = ~ /@($IDENTIFIER)($SPACE($PARAMETERS))?$SPACE/
	final static Pattern ANNOTATIONS = ~ /($ANNOTATION)+/
	final static Pattern ASSIGNMENT = ~ /(?:(\s)*=(?:[^;])*;(\s)*)/
	final static Pattern VARIABLE_OR_METHOD_REGEXP = ~ /($ANNOTATIONS)?($MODIFIERS)*$SPACE($TYPEIDENTIFIER)$SPACE($IDENTIFIER)($SPACE)?($PARAMETERS|$ASSIGNMENT)?/
	final static Pattern NON_EMPTY_SPACE= ~ /(\s)+/
	final static Pattern PACKAGEIDENTIFIER = ~ /(\w|_|\$|\.)+/
	final static Pattern packageRegExp = ~ /\b(package)$NON_EMPTY_SPACE($PACKAGEIDENTIFIER)(;|\b)/
	final static Pattern CLASS_REGEXP = ~ /($ANNOTATIONS)?($MODIFIERS)(class)$NON_EMPTY_SPACE($IDENTIFIER)/
	// see http://ostermiller.org/findcomment.html
	final static String COMMENT_REGEXP = "(?:/\\*(?:[^*]|(?:\\*+[^*/]))*\\*+/)|(?://.*)"
	final static String JAVA_BLOCK_REGEXP = "(?:(\\s)*\\{(?:[^\\}\\{])*\\}(\\s)*)"
}
