package de.beyondjava.simpleClassParser;

import java.util.List;

import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;

import de.beyondjava.beans.Address
import groovy.util.GroovyTestCase;
import static de.beyondjava.simpleClassParser.RegularExpressions.*

class SimpleClassParserTest extends GroovyTestCase {

	public void testStrings()
	{
		String anno = """@NotNull
	@Size(max=30,required="true",requir2ed="true")"""
		String s = """@NotNull(required=2)
	@Size(required="2")"""
		assertEquals("null", '"a"'.replaceAll(STRING3_REGEXP, "null"))
		assertEquals("null", '"{ba}"'.replaceAll(STRING3_REGEXP, "null"))
		assertEquals("null", '"""{ba}"""'.replaceAll(STRING2_REGEXP, "null"))
		assertEquals("null",s.replaceAll(ANNOTATIONS, "null"))
		assertEquals("null",'"{"'.replaceAll(STRING3_REGEXP, "null"))
	}
	public void testParser()
	{
		SimpleClassParser parser = new SimpleClassParser()
		List<ClassDefinition> classes = parser.parse("src/de/beyondjava/Beans")
		assertEquals(2, classes.size())
		int vars=0
		int meths=0
		classes.each({ClassDefinition c ->
			println "${c.className} contains ${c.variables?.size()} variables and ${c.methods?.size()} methods"
			vars += c.variables?.size()
			meths += c.methods?.size()
		})
		assertEquals(8, vars)
		assertEquals(4, meths)
	}
}
