package de.beyondjava.simpleClassParser;

import java.util.regex.Matcher
import java.util.regex.Pattern;

import com.google.gson.Gson;

import static RegularExpressions.*

/**
 * This a the definition of a variable.
 */
class VariableDefinition {
	public String toString()
	{
		Gson g = new Gson()
		g.toJson(this)
	}

	public VariableDefinition clone()
	{
		Gson g = new Gson()
		g.fromJson(g.toJson(this), VariableDefinition.class)
	}

	List<String> modifiers=[];
	String name;
	String type;
	List<String> annotations=[];
	String value=null; // optional

	/** Receives the complete variable definition source code and extracts the name,
	 *  the type and the visibility.
	 * @param p_variable variable definition (without assignment)
	 */
	VariableDefinition(String p_variable, String p_classnameForDebugging) {
		try
		{
			Matcher m = p_variable =~ ANNOTATION
			m.each({annotations = annotations + it[0].trim()})
			// simplify expression by removing annotations
			String variable = p_variable.replaceAll(ANNOTATION,"")
			// and assignments
			m = variable =~ ASSIGNMENT
			m.each({value = it[0].trim()})
			variable = variable.replaceAll(ASSIGNMENT,"")

			String[] words = variable.split(NON_EMPTY_SPACE.toString())
			name=words[-1]
			type=words[-2]
			if (words.length > 2) {
				modifiers=words[0..-3]
			}
		}
		catch (Exception p_error)
		{
			println "An error occured while parsing $p_classnameForDebugging: $p_error"
			println "while trying to evaluate the variable: '$p_variable'"
		}
	}

}
